# Sanitizer_ResourceMemoryData Struct Reference
[Sanitizer Callback API]

Data passed into a memory resource callback function. More...

## Data Fields

uint64_t | address
CUcontext | context
CUdevice | device
uint32_t | flags
Sanitizer_StreamHandle | hStream
CUmemoryPool | memoryPool
uint32_t | permissions
uint64_t | size
CUdevice | sourceDevice
CUstream | stream
Sanitizer_MemoryVisibility | visibility

## Detailed Description

Data passed into a memory resource callback function as the `cbdata` argument to Sanitizer_CallbackFunc. The `cbdata` will be this type for `domain` equal to SANITIZER_CB_DOMAIN_RESOURCE and `cbid` equal to SANITIZER_CBID_RESOURCE_DEVICE_MEMORY_ALLOC, SANITIZER_CBID_RESOURCE_DEVICE_MEMORY_FREE, SANITIZER_CBID_RESOURCE_HOST_MEMORY_ALLOC, SANITIZER_CBID_RESOURCE_HOST_MEMORY_FREE, SANITIZER_CBID_RESOURCE_MEMORY_ALLOC_ASYNC, SANITIZER_CBID_RESOURCE_MEMORY_FREE_ASYNC or SANITIZER_CBID_RESOURCE_MEMORY_FREE_ASYNC_DONE. The callback data is only valid within the invocation of the callback function that is passed the data. If you need to retain some data for use outside of the callback, you must make a copy of it.

## Field Documentation

uint64_t Sanitizer_ResourceMemoryData::address

Address of the allocation being created or destroyed.